# core/looper.py
#
#

""" time related functionality. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import error, get_name
from core.object import Object
from core import kernel, fleet

import threading
import logging
import time

# TIMER

class Timer(Object):

    def __init__(zelf, time_alarm, event, *args, **kwargs):
        Object.__init__(zelf, *args, **kwargs)
        zelf._sleep = time_alarm - time.time()
        zelf._timer = threading.Timer(zelf._sleep, zelf.echo)
        zelf._event = event

    def start(zelf, *args, **kwargs): zelf._timer.start()
        
    def echo(zelf, *args, **kwargs):
        for bot in fleet: bot.announce(zelf._event.get_rest())

## LOOPS

class Looper(Object):

    """ a Looper calls a function every x seconds. """ 

    def __init__(zelf, *args, **kwargs):
        """ args = function, sleeptime. """
        zelf._func = args[0]
        zelf.sleep = args[1]
        zelf._started = time.time()
        zelf._last = time.time()
        
    def start(zelf, *args, **kwargs):
        """ initialize a Looper. """
        zelf.cmnd = get_name(zelf._func)
        logging.info("looping %s" % zelf.cmnd)
        zelf._last = time.time()
        zelf._timer = threading.Timer(zelf.sleep, zelf.start)
        zelf._timer.start()
        try: zelf._func()
        except: error()

    def exit(zelf, *args, **kwargs): zelf._timer.cancel()
