# core/service/rss.py
#
#

""" rss module. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import parse_urls, short_date, fetch_url, error
from core.object import Object
from core.looper import Looper
from core import kernel

import threading
import logging
import socket
import time

## DEFINES

key_list = ["title", "description", "link"]

seen = Object()
seen.ctype = "rss_result"
seen.list = []

on_start = True

## display function

def display(*args, **kwargs):
    entry = args[0]
    counter = args[1]
    result = ""
    kernel.announce(" ")
    for key in key_list: kernel.announce("%s %s" % (counter, entry[key]))

## look function

def rss_fetch(*args, **kwargs):
    global on_start
    import core.contrib.feedparser as fp
    for obj in kernel.objects():
        if "rss" not in obj: continue
        counter = 1
        try: data = fetch_url("GET", obj.rss).read()
        except socket.error: error() ; continue
        try: data = fp.parse(data)
        except Exception as ex: error() ; continue
        for entry in data["entries"]:
            if entry["link"] not in seen.list:
                seen.list.append(entry["link"])
                display(entry, counter)
                counter += 1
    seen.sync()

kernel.cmnds.register("fetch", rss_fetch)

## INIT

def init(*args, **kwargs):
    global seen
    seen = kernel.last("ctype", "rss_result")
    if not seen: seen = Object() ; seen.list = []
    rss = Looper(rss_fetch, 600)
    kernel.run.rss = rss
    kernel.workers.put(rss.start)
